﻿using System;
using System.Data;
using System.Linq;
using System.Windows.Forms;
using Telerik.WinControls.UI;

namespace _897395
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            radGridView1.DataSource = GetTable();
            radGridView1.CreateCell += radGridView1_CreateCell;
            radGridView1.TableElement.TableHeaderHeight = 50;
          
            BaseGridBehavior gridBehavior = radGridView1.GridBehavior as BaseGridBehavior;
            gridBehavior.UnregisterBehavior(typeof(GridViewTableHeaderRowInfo));
            gridBehavior.RegisterBehavior(typeof(GridViewTableHeaderRowInfo), new MyGridHeaderRowBehavior());
            this.Load += Form1_Load;
            radGridView1.ViewCellFormatting += radGridView1_ViewCellFormatting; 
        }
        
        void radGridView1_ViewCellFormatting(object sender, CellFormattingEventArgs e)
        {
            if (e.CellElement.Text == "Speed" && e.CellElement is GridHeaderCellElement)
            {
                e.CellElement.TextAlignment = System.Drawing.ContentAlignment.MiddleLeft;
            }
            else
            {
                e.CellElement.ResetValue(LightVisualElement.TextAlignmentProperty, Telerik.WinControls.ValueResetFlags.Local);
            }
        }

        void Form1_Load(object sender, EventArgs e)
        {
            radGridView1.Columns["Speed"].Width = 80;
        }

        void radGridView1_CreateCell(object sender, Telerik.WinControls.UI.GridViewCreateCellEventArgs e)
        {
            if (e.Column.HeaderText == "Speed" && e.CellType == typeof(GridHeaderCellElement))
            {
                e.CellElement = new MyGridHeaderCellElement(e.Column,e.Row);
            }
        }

        static DataTable GetTable()
        {
            DataTable table = new DataTable();
            table.Columns.Add("Speed", typeof(int));
            table.Columns.Add("Drug", typeof(string));
            table.Columns.Add("Name", typeof(string));
            table.Columns.Add("Date", typeof(DateTime));
            
            table.Rows.Add(25, "Indocin", "David", DateTime.Now);
            table.Rows.Add(50, "Enebrel", "Sam", DateTime.Now);
            table.Rows.Add(10, "Hydralazine", "Christoff", DateTime.Now);
            table.Rows.Add(21, "Combivent", "Janet", DateTime.Now);
            table.Rows.Add(100, "Dilantin", "Melanie", DateTime.Now);
            return table;
        }
    }

    class MyGridHeaderCellElement : GridHeaderCellElement
    {
        public MyGridHeaderCellElement(GridViewColumn col, GridRowElement row) : base(col,row)
        {
        }

        protected override void CreateChildElements()
        {
            base.CreateChildElements();
            RadSpinElement element = new RadSpinElement();
          
            element.StretchVertically = false;
            element.StretchHorizontally = false;
            element.MinSize = new System.Drawing.Size(40, 20);

            element.Alignment = System.Drawing.ContentAlignment.MiddleRight;
            element.FitToSizeMode = Telerik.WinControls.RadFitToSizeMode.FitToParentBounds;
            element.MinValue = 0;
            element.MaxValue = 100;

            element.ValueChanged += element_ValueChanged;
            this.TextAlignment = System.Drawing.ContentAlignment.MiddleLeft;
            this.Children.Add(element);
        }

        void element_ValueChanged(object sender, EventArgs e)
        {
            RadGridView grid = this.GridControl;
        }

        protected override Type ThemeEffectiveType
        {
            get
            {
                return typeof(GridHeaderCellElement);
            }
        }
    }

    class MyGridHeaderRowBehavior : GridHeaderRowBehavior
    {
        public override bool OnMouseDown(MouseEventArgs e)
        {
            MyGridHeaderCellElement element = this.GridControl.ElementTree.GetElementAtPoint(e.Location) as MyGridHeaderCellElement;

            if (element != null)
            {
                return base.OnMouseDown(e);
            }
            return true;
        }
    }
}